package robust.pm.logger;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;

import org.apache.log4j.Appender;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.DailyRollingFileAppender;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;

import robust.pm.logger.LogWriter;


/**
 * logger
 */
public class CSLogger2 {
    
  //logger ʱȭ ƴ üũ Ѵ.
  public static boolean isInit = false;

  // ü Ͽ  ϵ Ѵ.
  private CSLogger2() {
      //
  }

  public static Logger logger = Logger.getRootLogger();

  public static synchronized void initLog() {
      
      if(isInit == false) {

        /////////////////////////////////////////
        // log4j 
    
        //logger.setLevel(Level.DEBUG);
        DailyRollingFileAppender appender = null;
        Appender consoleAppender = null;
    
        try {
          String logPattern =
              "%r [%t] %-5p %c %x - %m %d{yyyy MMM dd HH:mm:ss, SSS} \n";
          appender = new DailyRollingFileAppender(new PatternLayout(logPattern),
                                                  "syslog.log",
                                                  "'.'yyyy-MM-dd-HH-mm");
          consoleAppender = new ConsoleAppender(new PatternLayout(logPattern));
        }
        catch (IOException e) {
          e.printStackTrace();
          System.err.println("Logger Init Fail!.");
        }
    
        logger.addAppender(appender);
        logger.addAppender(consoleAppender);
        logger = Logger.getRootLogger();
    
        isInit = true;
    
        /////////////////////////////////////////
      }
  }

  /**
   * debug
   * @param Message Object
   */
  public static void debug(Object Message) {
  
      //if (!isInit) 
      //  HelperLogger.initLog();
        
      //    logger.debug(Message);

  }

  /**
   * info
   * @param Message Object
   */
  public static void info(Object Message) {
    
      //if (!isInit) 
      //    HelperLogger.initLog();

      // logger.info(Message);

  }

  /**
   * warn
   * @param Message Object
   */
  public static void warn(Object Message) {
    
      //if (!isInit) 
      //    HelperLogger.initLog();

      // logger.warn(Message);

  }

  /**
   * error
   * @param Message Object
   */
  public static void error(Object Message) {
    
      if (!isInit) 
          CSLogger2.initLog();
         
      logger.error(Message);

  }
  
  /**
   * error
   * @param Message Object
   */
  public static void error(Object Message, Throwable exp) {
    
      if (!isInit) 
          CSLogger2.initLog();
      
      LogWriter.getInstance().log(4, exp);
      logger.error(Message, exp);

  }
  

	
  /**
   * fatal
   * @param Message Object
   */
  public static void fatal(Object Message) {

      if (!isInit) 
          CSLogger2.initLog();

       logger.fatal(Message);

  }
  
  /**
   * fatal
   * @param Message Object
   */
  public static void fatal(Object Message, Throwable exp) {

      if (!isInit) 
          CSLogger2.initLog();

       logger.fatal(Message, exp);

  }
  
}
