/*
 * connκ user̸ϰ йȣ üũϰ !!
 */
package robust.pm.member;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.entity.ArticleEntity;


public class ProjectMemDAO {
	//ͺ̽    
	private Connection conn = null;
	private PreparedStatement pstmt = null;
	
	
	public ProjectMemDAO(){}

	public boolean insertDB(ProjectMemEntity projectMem) {

		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into projectMem(user_nm,user_grp_cd,last_sch_cd,major_nm,foreign_cap_cd,org_nm,dept_cd,post_cd,email,tel_no,hp_no,del_yn,reg_dtm) values(?,?,?,?,?,?,?,?,?,?,?,?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, projectMem.getUser_nm());
			pstmt.setString(2, projectMem.getUser_grp_cd());
			pstmt.setString(3, projectMem.getLast_sch_cd());
			pstmt.setString(4, projectMem.getMajor_nm());
			pstmt.setString(5, projectMem.getForeign_cap_cd());
			pstmt.setString(6, projectMem.getOrg_nm());
			pstmt.setString(7, projectMem.getDept_cd());
			pstmt.setString(8, projectMem.getPost_cd());
			pstmt.setString(9, projectMem.getEmail());
			pstmt.setString(10, projectMem.getTel_no());
			pstmt.setString(11, projectMem.getHp_no());
			pstmt.setString(12, projectMem.getDel_yn());
			pstmt.setString(13, projectMem.getReg_dtm());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}

	public boolean insertPrjMember(String gPrjId, String gUserId) {

		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "insert into tpart_psn(prj_id, user_id) values(?,?)";

		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, gPrjId);
			pstmt.setString(2, gUserId);

			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}
	
	public boolean deletePrjMember(String gPrjId, String gUserId) {

		//ϴ entity ּóѰ͵ Ƚ!
		String sql = "delete from tpart_psn where user_id like " 
			+ "\'" + gUserId + "\'" + " and prj_id like " + 
			"\'" + gPrjId + "\'";
		
		
		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sql);

			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}
	
	//̹ Ǿ ִ  ϴ 
	public boolean updateDB(ProjectMemEntity projectMem) {

		String sql = "update projectMem set user_nm=?,user_grp_cd=?,last_sch_cd=?,major_nm=?,foreign_cap_cd=?,org_nm=?,dept_cd=?,post_cd=?,email=?,tel_no=?,hp_no=?,del_yn=?,reg_dtm=? where user_id=?";
	
		try {
			conn = DBCPConn.getConnection("pool");
			
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, projectMem.getUser_nm());
			pstmt.setString(2, projectMem.getUser_grp_cd());
			pstmt.setString(3, projectMem.getLast_sch_cd());
			pstmt.setString(4, projectMem.getMajor_nm());
			pstmt.setString(5, projectMem.getForeign_cap_cd());
			pstmt.setString(6, projectMem.getOrg_nm());
			pstmt.setString(7, projectMem.getDept_cd());
			pstmt.setString(8, projectMem.getPost_cd());
			pstmt.setString(9, projectMem.getEmail());
			pstmt.setString(10, projectMem.getTel_no());
			pstmt.setString(11, projectMem.getHp_no());
			pstmt.setString(12, projectMem.getDel_yn());
			pstmt.setString(13, projectMem.getReg_dtm());
			pstmt.setString(14, projectMem.getUser_id());
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(int user_id) {                                 // from projectMem table  ??
		
		String sql = "delete from projectMem where user_id=?";

		try {
			
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, user_id);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		return true;
	}


	// Խù ϳ  ޼( / ȭ鿡 ʿ ͸ )
	public ProjectMemEntity getDB(String user_id) {
		
		String sql = "select * from tuser where user_id=?";                        // from guestbook table only?   The name 'getDB' & s'guestbook' are  ambiguous
		ProjectMemEntity projectMem = new ProjectMemEntity();

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, user_id);
			ResultSet rs = pstmt.executeQuery();

			if(rs.next())
			{
				projectMem.setUser_id(rs.getString("user_id"));
				projectMem.setUser_nm(rs.getString("user_nm"));
				projectMem.setUser_grp_cd(rs.getString("user_grp_cd"));
				projectMem.setLast_sch_cd(rs.getString("last_sch_cd"));
				projectMem.setMajor_nm(rs.getString("major_nm"));
				projectMem.setForeign_cap_cd(rs.getString("foreign_cap_cd"));
				projectMem.setOrg_nm(rs.getString("org_nm"));
				projectMem.setDept_cd(rs.getString("dept_cd"));
				projectMem.setPost_cd(rs.getString("post_cd"));
				projectMem.setEmail(rs.getString("email"));
				projectMem.setTel_no(rs.getString("tel_no"));
				projectMem.setHp_no(rs.getString("hp_no"));
				projectMem.setDel_yn(rs.getString("del_yn"));
				projectMem.setReg_dtm(rs.getString("reg_dtm"));
			}
			else
			{
				projectMem = null;
			}
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return projectMem;
	}


	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList<ProjectMemEntity> getDBList() {
		
		ArrayList<ProjectMemEntity> datas = new ArrayList<ProjectMemEntity>();

	

		String	sql = "select * from tuser";
		
		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);                                //  is proper use ?
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {

				ProjectMemEntity projectMem = new ProjectMemEntity();

				projectMem.setUser_id(rs.getString("user_id"));
				projectMem.setUser_nm(rs.getString("user_nm"));
				projectMem.setUser_grp_cd(rs.getString("user_grp_cd"));
				projectMem.setLast_sch_cd(rs.getString("last_sch_cd"));
				projectMem.setMajor_nm(rs.getString("major_nm"));
				projectMem.setForeign_cap_cd(rs.getString("foreign_cap_cd"));
				projectMem.setOrg_nm(rs.getString("org_nm"));
				projectMem.setDept_cd(rs.getString("dept_cd"));
				projectMem.setPost_cd(rs.getString("post_cd"));
				projectMem.setEmail(rs.getString("email"));
				projectMem.setTel_no(rs.getString("tel_no"));
				projectMem.setHp_no(rs.getString("hp_no"));
				projectMem.setDel_yn(rs.getString("del_yn"));
				projectMem.setReg_dtm(rs.getString("reg_dtm"));
				
				
				datas.add(projectMem);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
	
	
	public ArrayList<ProjectMemEntity> more_UserDBList(int startnum, int endnum) {
		
		
		ArrayList<ProjectMemEntity> datas = new ArrayList<ProjectMemEntity>();
		String sql = "select * from tuser where user_no between "+startnum+" and "+endnum;
	
		
		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();
			
			while (rs.next()) {
				ProjectMemEntity projectMem = new ProjectMemEntity();

				projectMem.setUser_id(rs.getString("user_id"));
				projectMem.setUser_nm(rs.getString("user_nm"));
				projectMem.setLast_sch_cd(rs.getString("last_sch_cd"));
				projectMem.setMajor_nm(rs.getString("major_nm"));
				projectMem.setForeign_cap_cd(rs.getString("foreign_cap_cd"));
				projectMem.setOrg_nm(rs.getString("org_nm"));
				projectMem.setDept_cd(rs.getString("dept_cd"));
				projectMem.setPost_cd(rs.getString("post_cd"));
				projectMem.setEmail(rs.getString("email"));
				projectMem.setTel_no(rs.getString("tel_no"));
				projectMem.setHp_no(rs.getString("hp_no"));
				projectMem.setDel_yn(rs.getString("del_yn"));
				projectMem.setReg_dtm(rs.getString("reg_dtm"));
				projectMem.setLast_upd_dtm(rs.getDate("last_upd_dtm"));
				projectMem.setUser_image(rs.getString("user_image"));
				//projectMem.setPrj_history(rs.getString("prj_history"));
				datas.add(projectMem);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
	public ArticleEntity recent_List() {
		
		//ArrayList<ArticleEntity> datas = new ArrayList<ArticleEntity>();

		ArticleEntity article = new ArticleEntity();
		String sql = "select * from article  order by posting_date desc limit 1";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			
			ResultSet rs = pstmt.executeQuery();			

			while (rs.next()) {
				

				article.setId(rs.getInt("article_id"));
				article.setGroupId(rs.getInt("group_id"));
				article.setSequenceNumber(rs.getString("sequence_no"));
				article.setPostingDate(rs.getDate("posting_date"));
				article.setReadCount(rs.getInt("read_count"));
				article.setWriterName(rs.getString("writer_name"));
				article.setPassword(rs.getString("password"));
				article.setTitle(rs.getString("title"));
				article.setContent(rs.getString("content"));
				//datas.add(article);
			}
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return article;
	}
	
	public String getUsersProjTaskNo(String userId, String projId)
	{
		String sql = "select task_no from ttask_mem where user_id like "+"\'" + userId + "\'"
					+ " and project_id like " + "\'" + projId + "\'" ;
		String task_no = new String("null");
		
		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();
			
			if (rs.next())
				task_no = rs.getString("task_no");
			
			
			rs.close();

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return task_no;
	}
	
	public String getProjCount(String userId)
	{
		String sql = "select count(*) AS count from tpart_psn where user_id like "+"\'" + userId + "\'";
		
		
		String projCount = new String("null");
		
		try {
		conn = DBCPConn.getConnection("pool");
		pstmt = conn.prepareStatement(sql);
		ResultSet rs = pstmt.executeQuery();
		
		if (rs.next())
			
			projCount = rs.getString("count");
		
		
		rs.close();
		
		} catch (SQLException e) {
		e.printStackTrace();
		} finally {
		try{
			pstmt.close();
			conn.close();
		}catch(SQLException sx) {}
		}
		
		return projCount;
		
	}
}
