package robust.pm.project;

import java.sql.Connection;

import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.ArrayList;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.project.ProjectInfoEntity;


public class ProjectInfoDAO {

	//Project̺ ϴ 
	public boolean insertDB(ProjectInfoEntity projectInfo) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		
	  /*  SimpleDateFormat sd = new SimpleDateFormat("yyyy/MM/dd");
	    
	    java.sql.Date st_Date = new java.sql.Date(sd.parse(projectInfo.getPrj_st_dt()).getTime());
	    java.sql.Date ed_Date = new java.sql.Date(sd.parse(projectInfo.getPrj_ed_dt()).getTime());
	    java.sql.Date last_up_Date = new java.sql.Date(sd.parse(projectInfo.getLast_upd_dtm()).getTime());*/

	    //prj_id ȳ־ǳ?????̤̤
	    String sql = "insert into tproject(prj_nm, prj_st_dt,prj_ed_dt,prj_tp_cd,pm_user_id, comp_rate, mm_cnt, psn_cnt, ord_org_nm, prog_stat_cd,reg_user_id, reg_dtm, last_upd_dtm) values(?,?,?,?,?,?,?,?,?,?,?,?,sysdate())";
		
		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);

			pstmt.setString(1, projectInfo.getPrj_nm());
			pstmt.setString(2, projectInfo.getPrj_st_dt());
			pstmt.setString(3, projectInfo.getPrj_ed_dt());
			pstmt.setString(4, projectInfo.getPrj_tp_cd());
			pstmt.setString(5, projectInfo.getPm_user_id());
			pstmt.setInt(6, projectInfo.getComp_rate());
			pstmt.setInt(7, projectInfo.getMm_cnt());	
			pstmt.setString(8, projectInfo.getPsn_cnt());	
			pstmt.setString(9, projectInfo.getOrd_org_nm());	
			pstmt.setString(10, projectInfo.getProg_stat_cd());	
			pstmt.setString(11, projectInfo.getReg_user_id());	
			pstmt.setString(12, projectInfo.getReg_dtm());	
			//pstmt.setString(13, projectInfo.getLast_upd_dtm());	

			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return true;
	}


	// ̹ Ǿ ִ  ϴ 
	public boolean updateDB(ProjectInfoEntity projectInfo) throws SQLException {
		Connection conn = null;
		PreparedStatement pstmt = null;
		/*  SimpleDateFormat sd = new SimpleDateFormat("yyyy/MM/dd");
	    
	    java.sql.Date st_Date = new java.sql.Date(sd.parse(projectInfo.getPrj_st_dt()).getTime());
	    java.sql.Date ed_Date = new java.sql.Date(sd.parse(projectInfo.getPrj_ed_dt()).getTime());
	    java.sql.Date last_up_Date = new java.sql.Date(sd.parse(projectInfo.getLast_upd_dtm()).getTime());*/

		String sql = "update tproject set prj_nm=?, prj_st_dt=?,prj_ed_dt=?,prj_tp_cd=?,pm_user_id=?, " +
				"comp_rate=?, mm_cnt=?, psn_cnt=?, ord_org_nm=?, prog_stat_cd=?,reg_user_id=?, reg_dtm=?, last_upd_dtm = sysdate() where prj_id=?";


		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
		pstmt.setString(1, projectInfo.getPrj_nm());
			pstmt.setString(2, projectInfo.getPrj_st_dt());
			pstmt.setString(3, projectInfo.getPrj_ed_dt());
			pstmt.setString(4, projectInfo.getPrj_tp_cd());
			pstmt.setString(5, projectInfo.getPm_user_id());
			pstmt.setInt(6, projectInfo.getComp_rate());
			pstmt.setInt(7, projectInfo.getMm_cnt());	
			pstmt.setString(8, projectInfo.getPsn_cnt());	
			pstmt.setString(9, projectInfo.getOrd_org_nm());	
			pstmt.setString(10, projectInfo.getProg_stat_cd());	
			pstmt.setString(11, projectInfo.getReg_user_id());	
			pstmt.setString(12, projectInfo.getReg_dtm());	
			pstmt.setInt(13, projectInfo.getPrj_id());	

			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		return true;
	}


	// Խù ϱ  ޼
	public boolean deleteDB(int prj_id) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		String sql = "delete from tpoject where prj_id=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, prj_id);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		return true;
	}

//////////////////////////////////////////////////////⼭! dateκ Ȯο!!
	
	
	// Խù ϳ  ޼( / ȭ鿡 ʿ ͸ )
	public ProjectInfoEntity getDB(int prj_id) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;	
	//	SimpleDateFormat sd = new SimpleDateFormat("yyyy/MM/dd");
		
		//java.util.Date st_Date = new java.util.Date(rs.getDate(projectInfo.getPrj_st_dt()).getTime());
		//java.sql.Date ed_Date = new java.sql.Date(sd.parse(projectInfo.getPrj_ed_dt()).getTime());
		//java.sql.Date last_up_Date = new java.sql.Date(sd.parse(projectInfo.getLast_upd_dtm()).getTime());

		
		

		String sql = "select * from tproject where prj_id=?";
		ProjectInfoEntity projectInfo = new ProjectInfoEntity();

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1, prj_id);
			ResultSet rs = pstmt.executeQuery();
			
			///////////////////̺κó!!̤
			//java.util.Date st_Date = new java.util.Date(rs.getDate(projectInfo.getPrj_st_dt()).getTime());
			//java.util.Date ed_Date = new java.sql.Date(rs.getDate(projectInfo.getPrj_ed_dt()).getTime());
			//java.util.Date last_up_Date = new java.sql.Date(rs.getDate(projectInfo.getLast_upd_dtm()).getTime());

			rs.next();
			projectInfo.setPrj_id(rs.getInt("prj_id"));
			projectInfo.setPrj_nm(rs.getString("prj_nm"));
			projectInfo.setPm_user_id(rs.getString("pm_user_id"));
			projectInfo.setOrd_org_nm(rs.getString("ord_org_nm"));
			projectInfo.setPrj_st_dt(rs.getString("prj_st_dt"));
			projectInfo.setPrj_ed_dt(rs.getString("prj_ed_dt"));
			projectInfo.setPrj_tp_cd(rs.getString("prj_tp_cd"));
			projectInfo.setComp_rate(rs.getInt("comp_rate"));
			projectInfo.setPsn_cnt(rs.getString("psn_cnt"));
			projectInfo.setProg_stat_cd(rs.getString("prog_stat_cd"));
			projectInfo.setReg_user_id(rs.getString("reg_user_id"));
			projectInfo.setReg_dtm(rs.getString("reg_dtm"));
			projectInfo.setLast_upd_dtm(rs.getDate("last_upd_dtm"));
			projectInfo.setMm_cnt(rs.getInt("mm_cnt"));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return projectInfo;
	}
		


	//Խù  ֱ  ϴ ż(͸ Ѳ ´)
	public ArrayList<ProjectInfoEntity> getDBList() {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ArrayList<ProjectInfoEntity> datas = new ArrayList<ProjectInfoEntity>();

		String sql = "select * from tproject";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			ResultSet rs = pstmt.executeQuery();
			
			while (rs.next()) {
				ProjectInfoEntity projectInfo = new ProjectInfoEntity();
				
				projectInfo.setPrj_id(rs.getInt("prj_id"));
				projectInfo.setPrj_nm(rs.getString("prj_nm"));
				projectInfo.setPm_user_id(rs.getString("pm_user_id"));
				projectInfo.setOrd_org_nm(rs.getString("ord_org_nm"));
				projectInfo.setPrj_st_dt(rs.getString("prj_st_dt"));
				projectInfo.setPrj_ed_dt(rs.getString("prj_ed_dt"));
				projectInfo.setPrj_tp_cd(rs.getString("prj_tp_cd"));
				projectInfo.setComp_rate(rs.getInt("comp_rate"));
				projectInfo.setPsn_cnt(rs.getString("psn_cnt"));
				projectInfo.setProg_stat_cd(rs.getString("prog_stat_cd"));
				projectInfo.setReg_user_id(rs.getString("reg_user_id"));
				projectInfo.setReg_dtm(rs.getString("reg_dtm"));
				projectInfo.setLast_upd_dtm(rs.getDate("last_upd_dtm"));
				projectInfo.setMm_cnt(rs.getInt("mm_cnt"));

				datas.add(projectInfo);	
				
			}
			rs.close();
			

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return datas;
	}
}
