package robust.pm.timesheet;

import java.sql.SQLException;
import java.util.ArrayList;

import robust.pm.project.ProjectInfoDAO;
import robust.pm.project.ProjectInfoEntity;
import robust.pm.user.UserDAO;
import robust.pm.user.UserEntity;

public class TimesheetManager{
	 private static TimesheetDAO            m_TimesheetDAO;
	public TimesheetManager(){
		
	
	}
 

    /**
     *======================================================
     * @޼ҵ : ProjectManager - get
     * @return  : ProjectEntity
     * @param pEntity  ڰ Entity
     * @    :  ȸѴ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static TimesheetEntity get( TimesheetEntity pEntity)throws SQLException {
      
        if ( m_TimesheetDAO == null) {
        	m_TimesheetDAO = new TimesheetDAO( );
        }
        
        return m_TimesheetDAO.get_UserDB(pEntity.getTs_id()) ;
    }

    /**
     *======================================================
     * @޼ҵ : ProjectManager - list
     * @return  : ProjectEntity[]
     * @param pEntity     Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    :   ȸѴ.
     *======================================================
     */
    public static ArrayList<TimesheetEntity> list( TimesheetEntity pEntity)throws SQLException {
      
        if ( m_TimesheetDAO == null) {
        	m_TimesheetDAO = new TimesheetDAO();
        }
        
        return m_TimesheetDAO.get_UserDBList();
    }
    /**
     *======================================================
     * @޼ҵ : ProjectManager - list
     * @return  : ProjectEntity[]
     * @param pEntity     Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    :   ȸѴ.
     *======================================================
     */
    public static ArrayList<TimesheetEntity> insert( TimesheetEntity pEntity)throws SQLException {
      
        if ( m_TimesheetDAO == null) {
        	m_TimesheetDAO = new TimesheetDAO();
        }
        
        return m_TimesheetDAO.get_UserDBList();
    }
    
    /**
     *======================================================
     * @޼ҵ : ProjectManager - list
     * @return  : ProjectEntity[]
     * @param pEntity     Entity
     * @param iPage		 
     * @param iPagePerCnt Ʈ
     * @    :   ȸѴ.
     *======================================================
     */
    
    public boolean updateDB(TimesheetEntity pEntity) throws SQLException{
    	if ( m_TimesheetDAO == null) {
        	m_TimesheetDAO = new TimesheetDAO();
        }
        
        return m_TimesheetDAO.updateDB(pEntity);
    }
    
    /**
     *======================================================
     * @޼ҵ : UserManager - insert
     * @return  : int  Ȯΰ
     * @param chkUserId   ̵
     * @    :   Ѵ.
     *======================================================
     * @̷ : , , 
     *
     *======================================================
     */
    public static boolean delete(TimesheetEntity pEntity,int ts_id) throws SQLException{
    	if ( m_TimesheetDAO == null) {
        	m_TimesheetDAO = new TimesheetDAO();
        }
        
        return m_TimesheetDAO.deleteDB(pEntity,ts_id);
    }

}
