<%@ page language="java" contentType="text/html; charset=EUC-KR" pageEncoding="EUC-KR"%>

<%@page import="robust.pm.notice.model.qArticleListModel"%>
<%@page import="robust.pm.notice.service.qListArticleService"%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ include file = "/common/include/include_auth.jsp" %>

<%
	String gUserID = authEntity.getUserId();
	String pageNumberString = _req.getParameter("p");
	int pageNumber = 1;
	if (pageNumberString != null && pageNumberString.length() > 0) {
		pageNumber = Integer.parseInt(pageNumberString);
	}
	qListArticleService listSerivce = qListArticleService.getInstance();
	qArticleListModel articleListModel = listSerivce.getArticleList(pageNumber);
	_req.setAttribute("listModel", articleListModel);
	
	if (articleListModel.getTotalPageCount() > 0) {
		int beginPageNumber = (articleListModel.getRequestPage() - 1) / 10 * 10 + 1;
		int endPageNumber = beginPageNumber + 9;
		if (endPageNumber > articleListModel.getTotalPageCount()) {
	endPageNumber = articleListModel.getTotalPageCount();
		}
		_req.setAttribute("beginPage", beginPageNumber);
		_req.setAttribute("endPage", endPageNumber);
	}
%>


<html>
<head><title>Խñ </title>
<style type="text\css">
</style>
<link href="/css/style_bbcs.css" rel="stylesheet" type="text/css">
</head>
<body>
<table width="1020" border="0" align="center" cellpadding="0" cellspacing="0">
<c:if test="${listModel.totalPageCount > 0}">              
                <tr>
                  
                  <td align="right"><img src="/images/bbcs/dot_04.gif">PAGE[<font color="ff7000">${listModel.requestPage}</font>/${listModel.totalPageCount}]</td>
                </tr>
                </c:if>
           	   <tr>
           	   <td align="left" class="pl2"><font size="4"><img src="/images/bbcs/icon_arrow_01.gif" border="0" align="absmiddle"><b> Խ</b></font></td>
           	   </tr>
           	   <tr>
               	 <td height="3" width="1020" bgcolor="#8CBDED"></td>
 							 </tr>
              </table>
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="mg_top10">
                <tr>
                  <td height="28" align="center" background="/images/bbcs/board_bg.gif"><table width="1000" border="0" cellspacing="0" cellpadding="0">
                      <tr>
                        <td width="80" align="center"><font color="787878"><b>ȣ</b></font></td>
                        <td width="1" bgcolor="acacac"></td>
                        <td align="center"><font color="787878"><b></b></font></td>
                        <td width="1" bgcolor="acacac"></td>
                        <td width="120" align="center"><font color="787878"><b>ۼ</b></font></td>
                        <td width="1" bgcolor="acacac"></td>
                        <td width="100" align="center"><font color="787878"><b>ۼ</b></font></td>
                        <td width="1" bgcolor="acacac"></td>
                        <td width="50" align="center"><font color="787878"><b>ȸ</b></font></td>
                      </tr>
                  </table></td>
                </tr>
                <c:choose>
                <c:when test="${listModel.hasArticle == false}">
									<tr>
                <td align="center" class="pt5 pb5"><table width="1000" border="0" cellspacing="0" cellpadding="2">
											<td class="list"><font color="787878">Խñ ϴ.</font></td>
										</table></td>
									</tr>
								</c:when>
                <c:otherwise>
						<c:forEach var="qarticle" items="${listModel.articleList}">
						<!-- 
							<c:if test="${article.level > 0}">
									<c:forEach begin="1" end="${article.level}">-</c:forEach>&gt;
							</c:if>
							-->
								<c:set var="query" value="qarticleId=${qarticle.id}&p=${listModel.requestPage}"/>
						<tr>
								<td align="center" class="pt5 pb5"><table width="1000" border="0" cellspacing="0" cellpadding="2">
								<td width="80" height="25" align="center" class="list"><font color="787878"><b>${qarticle.id}</b></font></td>
								<td class="list"><font color="787878"><a href="<c:url value="/service/project/notice/read.jsp?${query}"/>" class ="link_03">${qarticle.title}</a></font></td>
								<td width="100" align="center" class="list"><font color="787878">${qarticle.writerName}</font></td>
								<td width="110" align="center" class="list"><font color="787878"><fmt:formatDate value="${qarticle.postingDate}" pattern="yyyy-MM-dd" /></font></td>
								<td width="40" align="center" class="list"><font color="787878">${qarticle.readCount}</font></td>
						</table></td></tr>
	</c:forEach>
	<tr>
		<td align="center">
		
		<c:if test="${beginPage > 3}">
			<a href="<c:url value="/service/project/notice/list.jsp?p=${beginPage-1}"/>"></a>
		</c:if>
		<c:forEach var="pno" begin="${beginPage}" end="${endPage}">
		<a href="<c:url value="/service/project/notice/list.jsp?p=${pno}" />">[${pno}]</a>
		</c:forEach>
		<c:if test="${endPage < listModel.totalPageCount}">
			<a href="<c:url value="/service/project/notice/list.jsp?p=${endPage + 1}"/>"></a>
		</c:if>
		</td>
	</tr>
	</c:otherwise>
  </c:choose>
  
  
  <tr>
  	<td align="right" class="pl2"><a href="writeForm.jsp"><img src="/images/bbcs/write_pen.GIF"></a></td>
  </tr>
</table>  
            
</body>
</html>