package robust.pm.android;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.android.userEntity;

public class userDAO {
	public userEntity getUserDB(String user_id) {
		Connection conn = null;
		PreparedStatement pstmt = null;
		
		userEntity userEntityInstance = new userEntity();	
		
		String sql = "select * from tuser where user_id=?";

		try {
			conn = DBCPConn.getConnection("pool");
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, user_id);
			ResultSet rs = pstmt.executeQuery();

			rs.next();

			userEntityInstance.setID(rs.getString("user_id"));
			userEntityInstance.setPwd(rs.getString("password"));

			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			try{
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}

		return userEntityInstance;
	}
}