package robust.pm.main;

import java.sql.DriverManager;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

import robust.pm.dbmanager.DBCPConn;
import robust.pm.main.MainEntity;
import robust.pm.user.UserEntity;
import robust.pm.util.StringUtil;
import robust.pm.logger.CSLogger;

import robust.pm.project.ProjectInfoEntity;

/**
 *======================================================
 * @Ŭ : MainDAO
 * @    : ȭ  DAO
 *======================================================
 * @̷ - , , 
 *
 *======================================================
 */ 

public class MainDAO {

	/**
	 * α  Ʈ  ȸ
	 * @param conn
	 * @param pEntity
	 * @return
	 * @throws SQLException
	 */
	public ProjectInfoEntity[] list(String gUserId) throws SQLException {
		Connection conn = null;
		PreparedStatement pstmt = null;
		ResultSet rset = null;
		
		Vector vec = new Vector();
		ProjectInfoEntity[] entities = null;
		ProjectInfoEntity entity = null;
		
		int index = 1;

		/** TPROJECT ̺  ȸѴ. **/
		String qry = "	SELECT							\n"
				+	"		A.PRJ_ID, A.PRJ_NM,			\n"
				+	"		A.PROG_STAT_CD				\n"
				+	"	FROM							\n"
				+	"		TPROJECT A JOIN TPART_PSN B	\n"				
				+	"		ON 							\n"				
				+	"			A.PRJ_ID = B.PRJ_ID		\n"
				+	"			AND B.USER_ID = ?		\n"
				+	"	ORDER BY A.PROG_STAT_CD, A.REG_DTM DESC	\n";
		
		try {
			
			conn = DBCPConn.getConnection("pool");

			CSLogger.debug(qry);
			
			pstmt = conn.prepareStatement(qry);
			
			pstmt.setString(index++, gUserId);

			rset = pstmt.executeQuery();
		    int colSeq = 1;
		    
			while (rset.next()) {
				colSeq = 1;
				entity = new ProjectInfoEntity();
				entity.setPrj_id(Integer.parseInt(rset.getString(colSeq++)));
				entity.setPrj_nm(rset.getString(colSeq++));
				entity.setProg_stat_cd(rset.getString(colSeq++));
				
				vec.addElement(entity);
			}

		}catch (SQLException sqle) {
			CSLogger.error(sqle.toString());
			throw sqle;
		} catch (Exception sqle) {
			CSLogger.error(sqle.toString());
		} finally {
			try{
				rset.close();
				pstmt.close();
				conn.close();
			}catch(SQLException sx) {}
		}
		
		if (vec.size() > 0) {
			entities = new ProjectInfoEntity[vec.size()];
			vec.copyInto(entities);
			vec.clear();
			vec = null;
		}
		
		return entities;
	}
	
}
