package robust.pm.util;


import javax.servlet.*;
import javax.servlet.http.*;

import java.net.*;
import java.io.*;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;

public class CookieUtil {
    
    /**
     * <code>getValue</code> Ű  ִ   ´.
     * @param Cookie[] cookies  
     * @param String name       
     * @param String ⺻
     * @return String  .
     */
    public static String getValue(Cookie[] cookies, String name, String sDefault) {

        if(cookies == null) return null;
    
        for(int i=0; i<cookies.length; i++) {
            if(name.equals(cookies[i].getName()))
                return cookies[i].getValue();
        }
        
        return sDefault;
    }

    /**
     * <code>getValue</code> Ű  ִ   ´.
     * @param Cookie[] cookies  
     * @param String name       
     * @return String  .
     */
    public static String getValue(Cookie[] cookies, String name) {

        if(cookies == null) return null;
    
        for(int i=0; i<cookies.length; i++) {
            if(name.equals(cookies[i].getName()))
                return cookies[i].getValue();
        }
        
        return null;
    }
    
    /**
     * <code>getCookie</code> Cookie  ´.
     * @param Cookie[] cookies  
     * @param String name   
     * @return Cookie
     */
    public static Cookie getCookie(Cookie[] cookies, String name) {

        if(cookies == null) return null;
    
        for(int i=0; i<cookies.length; i++) {
            if(name.equals(cookies[i].getName()))
                return cookies[i];
        }
        
        return null;
    }

    /**
     * <code>setCookie</code> Cookie Ѵ.
     * @param resp  HttpServletResponse
     * @param sName Ű
     * @param sValue Ű 
     */
    public static void setCookie(HttpServletResponse resp, String sName, String sValue) {

        Cookie      c       =   null;
        c   =   new Cookie(sName, sValue);
        c.setPath("/");
        resp.addCookie(c);

        return;
    }
}
