package robust.pm.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class caculateDate {
	// ¥  Ⱓ ϴ Լ.
	public long getDayPeriod(String stdate, String endate) throws ParseException {
		Date startDate = string_to_date(stdate);
		Date endDate = string_to_date(endate);

		Calendar stDateCal = Calendar.getInstance();
		Calendar enDateCal = Calendar.getInstance();

		stDateCal.setTime(startDate);
		enDateCal.setTime(endDate);

		long period = (enDateCal.getTimeInMillis() - stDateCal
				.getTimeInMillis()) / (1000 * 60 * 60 * 24);

		return period+1;
	}
	
/*	// ¥  Ⱓ ϴ Լ.
	public long getMonthPeriod(String stdate, String endate) throws ParseException {
		Date startDate = string_to_date(stdate);
		Date endDate = string_to_date(endate);

		Calendar stDateCal = Calendar.getInstance();
		Calendar enDateCal = Calendar.getInstance();

		stDateCal.setTime(startDate);
		enDateCal.setTime(endDate);

		long period = (enDateCal.getTimeInMillis() - stDateCal
				.getTimeInMillis()) / (1000 * 60 * 60 * 24 * 30);

		return period;
	}*/

	//Ʈ    ϼ ȯϴ Լ. -To.  From. ŴϾ!- 
	public long getIng(String projdate) throws ParseException {
		Date projDate = string_to_date(projdate);
		Date curDate = new Date();
	
		Calendar stDateCal = Calendar.getInstance();
		Calendar enDateCal = Calendar.getInstance();
	
		stDateCal.setTime(curDate);
		enDateCal.setTime(projDate);

		long period = ((enDateCal.getTimeInMillis()-stDateCal.getTimeInMillis())
				/ (1000 * 60 * 60 * 24));

		return period+1;
	}
	
	public String getToday() throws ParseException {
		Calendar DateCal = Calendar.getInstance();
		DateCal.setTime(new Date());

		return DateCal.get(Calendar.YEAR)+"-"+DateCal.get(Calendar.MONTH)+"-"+DateCal.get(Calendar.DAY_OF_MONTH);
	}

	// ¥ String  ȯ ϴ Լ.
	public String getCurDate() {
		return date_to_string(new Date());
	}
	
	//Date  String   ϴ Լ.
	public String date_to_string(Date dateDate) {
		DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
		String strDate = df.format(dateDate);

		return strDate;
	}
	
	//String  Date   ϴ Լ.
	public Date string_to_date(String strDate) throws ParseException {
		Date dateDate = (new SimpleDateFormat("yyyy-MM-dd")).parse(strDate);
		return dateDate;
	}
	
	//Է    ޿    ȯϴ Լ 
	public int remainderOfPeriod(int month, int day) {
	
		int _date = 0;
		int _period;

		switch (month) {
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12:
			_date = 31;
			break;
		case 4:
		case 6:
		case 9:
		case 11:
			_date = 30;
			break;
		case 2:
			_date = 28;
			break;
		}

		_period = _date - day;
		
		return _period+1;
	}
}